﻿using System;
using System.IO;
using System.Net;
using System.Text;
using System.Web.Script.Serialization;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            Console.Write("검색 키워드 : ");

            string keyword = Console.ReadLine();

            string url        = $"https://dapi.kakao.com/v2/local/search/keyword.json?query={keyword}";
            string restAPIKey = "[REST API 키를 설정해 주시기 바랍니다]";
            string header     = $"KakaoAK {restAPIKey}";

            WebRequest request = WebRequest.Create(url);

            request.Headers.Add("Authorization", header);

            WebResponse response = request.GetResponse();

            string json = null;

            using(Stream stream = response.GetResponseStream())
            {
                StreamReader reader = new StreamReader(stream, Encoding.UTF8);

                json = reader.ReadToEnd();
            }

            if(string.IsNullOrEmpty(json))
            {
                return;
            }

            JavaScriptSerializer serializer = new JavaScriptSerializer();

            dynamic responseData = serializer.Deserialize<dynamic>(json);
            dynamic documents    = responseData["documents"];

            int length = ((object[])documents).Length;

            for(int i = 0; i < length; i++)
            {
                string placeName = documents[i]["place_name"];
                string x         = documents[i]["x"];
                string y         = documents[i]["y"];

                Console.WriteLine($"{placeName} : {x}, {y}");
            }
        }

        #endregion
    }
}